Index: /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj	(revision 12262)
@@ -72,7 +72,8 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="DTO\LocalAlbumList.cs" />
+    <Compile Include="DTO\LocalPwgImage.cs" />
     <Compile Include="DTO\ModelManager.cs" />
     <Compile Include="DTO\SelectedList.cs" />
-    <Compile Include="Helper\SelectedListHelper.cs" />
     <Compile Include="MainForm.cs">
       <SubType>Form</SubType>
@@ -84,6 +85,10 @@
     <Compile Include="Program.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Service\UploadToPiwigo.cs" />
     <Compile Include="Service\Disconnect.cs" />
     <Compile Include="Service\ServiceFactory.cs" />
+    <EmbeddedResource Include="MainForm.fr.resx">
+      <DependentUpon>MainForm.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="MainForm.resx">
       <DependentUpon>MainForm.cs</DependentUpon>
@@ -101,5 +106,6 @@
     </Compile>
     <None Include="app.config" />
-    <None Include="Properties\DataSources\Com.Piwigo.Uploader.DTO.PwgCategoryList.datasource" />
+    <None Include="Properties\DataSources\Com.Piwigo.Uploader.DTO.ModelManager+ModelManagerBase.datasource" />
+    <None Include="Properties\DataSources\Com.Piwigo.Uploader.DTO.SelectedPwgCategoryList.datasource" />
     <None Include="Properties\Settings.settings">
       <Generator>SettingsSingleFileGenerator</Generator>
Index: /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj.user
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj.user	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj.user	(revision 12262)
@@ -11,3 +11,6 @@
     <VerifyUploadedFiles>false</VerifyUploadedFiles>
   </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|AnyCPU'">
+    <StartArguments>C:\Users\Public\Pictures</StartArguments>
+  </PropertyGroup>
 </Project>
Index: /extensions/PiwigoLib/PiwigoUpload/Service/Connect.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Service/Connect.cs	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoUpload/Service/Connect.cs	(revision 12262)
@@ -8,4 +8,5 @@
 
 using Com.Piwigo.Uploader.DTO;
+using Com.Piwigo.Uploader.Helper;
 
 namespace Com.Piwigo.Uploader.Service
@@ -21,14 +22,17 @@
             try
             {
+                List<PwgCategory> lstPCat  = null;
                 ModelManager.Instance.sess = PwgServiceProvider.Instance.PwgSessionService.Login( ModelManager.Instance.userName,  ModelManager.Instance.password);
+                ModelManager.Instance.isConnected = true;
+
                 System.Diagnostics.Debug.WriteLine("user : " + ModelManager.Instance.sess.UserName + " " + ModelManager.Instance.sess.Status);
 
-                if (ModelManager.Instance.sess.Status == PwgSessionStatusEnum.WebMaster)
+                lstPCat = PwgServiceProvider.Instance.PwgCategoriesService.GetListOfCategory(PwgCategory.RootCategoryId, true,null);
+
+                ModelManager.Instance.resetLstCat();
+
+                foreach (PwgCategory item in lstPCat)
                 {
-                    ModelManager.Instance.lstCat = PwgServiceProvider.Instance.PwgCategoriesService.GetAdminListOfCategory();
-                }
-                else
-                {
-                    ModelManager.Instance.lstCat = PwgServiceProvider.Instance.PwgCategoriesService.GetListOfCategory(PwgCategory.RootCategoryId, true, false);
+                    ModelManager.Instance.lstCat.Add(new SelectedCategoryListItem() { ShowedValue = (String.IsNullOrWhiteSpace(item.Name) ? "album " + item.Id : item.Name), Id = item.Id, Data = item, isSelected = false });
                 }
 
Index: /extensions/PiwigoLib/PiwigoUpload/Service/Disconnect.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Service/Disconnect.cs	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoUpload/Service/Disconnect.cs	(revision 12262)
@@ -18,4 +18,5 @@
             {
                 ModelManager.Instance.sess = PwgServiceProvider.Instance.PwgSessionService.Logout();
+                ModelManager.Instance.isConnected = false;
                 System.Diagnostics.Debug.WriteLine("user : " + ModelManager.Instance.sess.UserName + " " + ModelManager.Instance.sess.Status);
             }
Index: /extensions/PiwigoLib/PiwigoUpload/Service/LoadFromDirectory.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Service/LoadFromDirectory.cs	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoUpload/Service/LoadFromDirectory.cs	(revision 12262)
@@ -3,4 +3,6 @@
 using System.Linq;
 using System.Text;
+using System.IO;
+using Com.Piwigo.Uploader.DTO;
 
 namespace Com.Piwigo.Uploader.Service
@@ -8,7 +10,40 @@
     public class LoadFromDirectory : IService 
     {
+        string[] extensions = { ".jpeg", ".jpg" };
+
+        private LocalAlbum loadDirectory(String dirName, Int32? rootAlbumId)
+        {
+            DirectoryInfo dir = new DirectoryInfo(dirName); 
+            LocalAlbum album = new LocalAlbum (){ LocalDir=dir.FullName, Name=dir.Name};
+            album.MessageInfo = "";
+            album.UpperCatId = rootAlbumId;
+            
+            // loading image data in album
+            album.LocalImages = new LocalImageList();
+            foreach (string strfile in Directory.EnumerateFiles(dir.FullName, "*.*", SearchOption.TopDirectoryOnly)
+                .Where(s => extensions.Any(ext => ext == Path.GetExtension(s))))
+            {
+                FileInfo fi = new  FileInfo(strfile);
+                LocalImage img = new LocalImage();
+                img.LocalFile = fi.FullName;
+                img.Name = fi.Name;
+                album.LocalImages.Add(img);
+            }
+
+            album.SubAlbums = new LocalAlbumList();
+            foreach (string strdir in Directory.EnumerateDirectories(dir.FullName))
+            {
+                album.SubAlbums.Add(loadDirectory(strdir, null));
+            }
+
+            return album;
+        }
+
         public void runService()
         {
-            throw new NotImplementedException();
+            ModelManager.Instance.lstAlbumLocaux.Add(
+                loadDirectory(ModelManager.Instance.directoryName,
+                null)
+                );
         }
     }
Index: /extensions/PiwigoLib/PiwigoUpload/Service/ServiceFactory.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Service/ServiceFactory.cs	(revision 12261)
+++ /extensions/PiwigoLib/PiwigoUpload/Service/ServiceFactory.cs	(revision 12262)
@@ -22,4 +22,7 @@
                 case "LoadFromDirectory":
                     objICom = aLoadFromDirectory;
+                    break;
+                case "UploadToPiwigo":
+                    objICom = aUploadToPiwigo;
                     break;
                 default:
@@ -68,4 +71,17 @@
             }
         }
+
+        private static IService _aUploadToPiwigo;
+        private static IService aUploadToPiwigo
+        {
+            get
+            {
+                if (_aUploadToPiwigo == null)
+                {
+                    _aUploadToPiwigo = new UploadToPiwigo();
+                }
+                return _aUploadToPiwigo;
+            }
+        }
     }
 }
Index: /extensions/PiwigoLib/PiwigoUpload/Service/UploadToPiwigo.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Service/UploadToPiwigo.cs	(revision 12262)
+++ /extensions/PiwigoLib/PiwigoUpload/Service/UploadToPiwigo.cs	(revision 12262)
@@ -0,0 +1,34 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.IO;
+using Com.Piwigo.Uploader.DTO;
+using Com.Piwigo.Lib.DTO;
+
+namespace Com.Piwigo.Uploader.Service
+{
+    public class UploadToPiwigo : IService 
+    {
+        public void runService()
+        {
+            foreach (LocalAlbum Alb in ModelManager.Instance.lstAlbumLocaux)
+            {
+                uploadAlbum(Alb, ModelManager.Instance.PwgCategoryIdSelected);
+            } 
+        }
+
+        internal static void uploadAlbum(LocalAlbum aAlbum, Int32? catId)
+        {
+            foreach (LocalImage Img in aAlbum.LocalImages)
+            {
+                //uploadimage();
+            }
+
+            foreach (LocalAlbum Alb in aAlbum.SubAlbums)
+            {
+                uploadAlbum(Alb, null);
+            }
+        }
+    }
+}
Index: /extensions/PiwigoLib/PiwigoUpload/Settings.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Settings.cs	(revision 12262)
+++ /extensions/PiwigoLib/PiwigoUpload/Settings.cs	(revision 12262)
@@ -0,0 +1,29 @@
+﻿namespace Com.Piwigo.Uploader.Properties
+{
+    
+    
+    // Cette classe vous permet de gérer des événements spécifiques dans la classe de paramètres :
+    //  L'événement SettingChanging est déclenché avant la modification d'une valeur de paramètre.
+    //  L'événement PropertyChanged est déclenché après la modification d'une valeur de paramètre.
+    //  L'événement SettingsLoaded est déclenché après le chargement des valeurs de paramètre.
+    //  L'événement SettingsSaving est déclenché avant l'enregistrement des valeurs de paramètre.
+    internal sealed partial class Settings {
+        
+        public Settings() {
+            // Pour ajouter des gestionnaires d'événements afin d'enregistrer et de modifier les paramètres, supprimez les marques de commentaire des lignes ci-dessous :
+            
+            //this.SettingChanging += this.SettingChangingEventHandler;
+            
+            //this.SettingsSaving += this.SettingsSavingEventHandler;
+            
+        }
+        
+        private void SettingChangingEventHandler(object sender, System.Configuration.SettingChangingEventArgs e) {
+            // Ajouter du code pour gérer l'événement SettingChangingEvent ici.
+        }
+        
+        private void SettingsSavingEventHandler(object sender, System.ComponentModel.CancelEventArgs e) {
+            // Ajouter du code pour gérer l'événement SettingsSaving ici.
+        }
+    }
+}
Index: /extensions/PiwigoLib/PiwigoWpf/DTO/LocalPwgImage.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoWpf/DTO/LocalPwgImage.cs	(revision 12262)
+++ /extensions/PiwigoLib/PiwigoWpf/DTO/LocalPwgImage.cs	(revision 12262)
@@ -0,0 +1,76 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.ComponentModel;
+using Com.Piwigo.Lib.DTO;
+
+namespace Com.Piwigo.Wpf.DTO
+{
+    public class LocalPwgImageListWPF : AsyncObservableCollection<LocalPwgImageWPF>
+    {}
+
+    public class LocalPwgImageWPF : INotifyPropertyChanged
+    {
+        //FileInfo highResFile, FileInfo lowResFile, FileInfo thumbFile, String imageName, String imageAuthor, DateTime creationDate,
+        //    String authorComment, List<String> lstCategories, List<String> lstTags, PwgConfidentLevelEnum? confidentLevel
+
+        private Int32 _id;
+        public Int32 Id
+        {
+            set { _id = value; OnPropertyChanged("Id"); }
+            get { return _id; }
+        }
+
+        private String _authorComment;
+        public String AuthorComment
+        {
+            set { _authorComment = value; OnPropertyChanged("AuthorComment"); }
+            get { return _authorComment; }
+        }
+
+        private String _name;
+        public String Name
+        {
+            set { _name = value; OnPropertyChanged("Name"); }
+            get { return _name; }
+        }
+
+        private String _localFile;
+        public String LocalFile
+        {
+            set { _localFile = value; OnPropertyChanged("LocalFile"); }
+            get { return _localFile; }
+        }
+
+        private Int32 _upperCatId;
+        public Int32 UpperCatId
+        {
+            set { _upperCatId = value; OnPropertyChanged("UpperCatId"); }
+            get { return _upperCatId; }
+        }
+
+        private AsyncObservableCollection<PwgTagWPF> _lstTags;
+        public  AsyncObservableCollection<PwgTagWPF> LstTags
+        {
+            set { _lstTags = value; OnPropertyChanged("LstTags"); }
+            get { return _lstTags; }
+        }
+
+        private PwgConfidentLevelEnum _confidentialLevel;
+        public PwgConfidentLevelEnum ConfidentialLevel
+        {
+            set { _confidentialLevel = value; OnPropertyChanged("ConfidentialLevel"); }
+            get { return _confidentialLevel; }
+        }
+
+        public event PropertyChangedEventHandler PropertyChanged;
+        protected void OnPropertyChanged(String info)
+        {
+            if (PropertyChanged != null)
+                PropertyChanged(this, new PropertyChangedEventArgs(info));
+        }
+
+
+    }
+}
